## adsys 0.8.4

=== vendor/github.com/pelletier/go-toml/Makefile ===
export CGO_ENABLED=0
go := go
go.goos ?= $(shell echo `go version`|cut -f4 -d ' '|cut -d '/' -f1)
go.goarch ?= $(shell echo `go version`|cut -f4 -d ' '|cut -d '/' -f2)

out.tools := tomll tomljson jsontoml
out.dist := $(out.tools:=_$(go.goos)_$(go.goarch).tar.xz)
sources := $(wildcard **/*.go)


.PHONY:
tools: $(out.tools)

$(out.tools): $(sources)
	GOOS=$(go.goos) GOARCH=$(go.goarch) $(go) build ./cmd/$@

.PHONY:
dist: $(out.dist)

$(out.dist):%_$(go.goos)_$(go.goarch).tar.xz: %
	if [ "$(go.goos)" = "windows" ]; then \
		tar -cJf $@ $^.exe; \
	else \
		tar -cJf $@ $^; \
	fi

.PHONY:
clean:
	rm -rf $(out.tools) $(out.dist)

=== vendor/gitlab.com/bosi/decorder/Makefile ===
include project-templates/base.mk

project-templates/base.mk:
	@cp -ar ~/.dotfiles/projects/golang ./project-templates

.env:
	touch .env

## adsys 0.5

=== debian/changelog ===
adsys (0.5) hirsute; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Add integration tests to cover (all but policy update command):
    - command line parsing and handling
    - interaction between daemon and client
  * Add tests and coverage support for python embedded code to interact with
    samba (ldap AD connection).
  * Create a samba mock to test adsys-gpolist.
  * Add a container to control and tests polkitd with our uninstalled,
    current version in branch .policy file on its own couple of system dbus.
  * Abstract many test helpers in their own function to be more reusable.
  * Code cleanup (races, shutdown handling and other fixes) detected
    via the new tests.
  * CI coverage integration.
  * Various CI fixes on tagged version.

 -- Didier Roche <didrocks@ubuntu.com>  Fri, 16 Apr 2021 09:53:07 +0200

adsys (0.4) hirsute; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Disable LTO to fix FTBFS
  * Fix Version test on released package
  * Fix timeout idler race
  * Add tests for logstreamer
  * Misc cleanups

 -- Didier Roche <didrocks@ubuntu.com>  Thu, 01 Apr 2021 10:23:52 +0200

adsys (0.3) hirsute; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Fix namespace in admx files to avoid conflict with Windows one.
  * Special case GDM user as a machine to support login screen configuration
    in both admx and policy daemon side.
  * CI fixes and additions for admx generation and tests. Enable devel (hirsute) series.
  * Multiple gosec fixes.
  * Add missing samba dependencies to packaging
  * Graceful stop handling fixes.
  * Lot of new tests
  * Multiple fixes/races discovered by tests

 -- Didier Roche <didrocks@ubuntu.com>  Thu, 25 Mar 2021 10:58:58 +0100

adsys (0.2) hirsute; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Fix FTBFS due to race:
    - workaround amd64 mkdirall while creating directory for pam module
      integration
    - fix sigchild flag capture, including additional flags on non amd64,
      before restoring them after each samba call to workaround libsamba
      signals override.
  * Fix utf-16 and memory management when .pol windows file are more than 4106
    size long (-8 header bytes > 4096).
  * Fix GPO list order when a policy is enforced
  * Embed GPO list python helper inside the go binary
  * Fix emptying a GPO after setting value doesn’t reset the applied policy
  * Fix multi-lines support while dumping applied policies
  * Internal: rename "default" dconf metadata to "empty" for clarity

 -- Didier Roche <didrocks@ubuntu.com>  Thu, 25 Feb 2021 10:11:13 +0100

adsys (0.1) hirsute; urgency=medium

  * Initial release

 -- Didier Roche <didrocks@ubuntu.com>  Fri, 08 Jan 2021 16:35:16 +0100

=== debian/control ===
Source: adsys
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 13),
               dh-apport,
               dh-golang,
               golang-go (>= 2:1.16~),
               libsmbclient-dev,
               libdbus-1-dev,
               python3,
               python3-samba,
               samba-dsdb-modules,
               libpam0g-dev,
               samba,
               dbus,
Standards-Version: 4.5.1
XS-Go-Import-Path: github.com/ubuntu/adsys
Homepage: https://github.com/ubuntu/adsys
Description: AD SYStem integration
 ADSys is an AD SYStem tool to integrate GPOs with a linux system.
 It allows one to handle machine and users GPOs, mapping them to dconf keys,
 apparmor rules and running scripts at different point in time.


Package: adsys
Architecture: any
Built-Using: ${misc:Built-Using},
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python3,
         python3-samba,
         samba-dsdb-modules,
         sssd,
         krb5-config,
Description: ${source:Synopsis}
 ${source:Extended-Description}

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export GOCACHE=$(shell mktemp -d /tmp/gocache-XXXX)
export GOFLAGS=-ldflags=-X=github.com/ubuntu/adsys/internal/config.Version=$(shell dpkg-parsechangelog -S Version) --mod=vendor
export DH_GOLANG_INSTALL_EXTRA := internal/policies/ad/admxgen/admx.template internal/policies/ad/admxgen/adml.template

# Install all content to embed
export DH_GOLANG_INSTALL_ALL := 1

# The package fails to build on duplicate symbols in the archive with LTO enabled
export DEB_BUILD_MAINT_OPTIONS=optimize=-lto

# Skip integration tests when building package: they need docker images.
export ADSYS_SKIP_INTEGRATION_TESTS=1

%:
	dh $@ --buildsystem=golang --with=golang,apport

override_dh_auto_clean:
	dh_auto_clean
	# create the vendor directory when building the source package
	[ -d vendor/ ] || go mod vendor

override_dh_auto_install:
	dh_auto_install -- --no-source
	# install in /sbin
	mv debian/adsys/usr/bin/ debian/adsys/sbin
	rmdir debian/adsys/usr/
	# create adsysctl command
	ln -s adsysd debian/adsys/sbin/adsysctl
	# Workaround file system race making debian/adsys/lib/ a file while it’s a directory
	mkdir debian/adsys/lib
	# run go generate to install assets, but don’t regenerate them
	GENERATE_ONLY_INSTALL_TO_DESTDIR=$(CURDIR)/debian/adsys go generate -tags tools $(GOFLAGS) ./...
	# remove admxgen helper from installation
	rm debian/adsys/sbin/admxgen

=== debian/tests/control ===
# Skip integration tests when building package: they need docker images.
Test-Command: sudo ADSYS_SKIP_INTEGRATION_TESTS=1 go test -v -mod=vendor ./...
Restrictions: allow-stderr
Depends: @builddeps@

## adsys 0.7.1

=== debian/changelog ===
adsys (0.7.1) impish; urgency=medium

  * Fix user login name when being prefixed by domain (domain\user) or using
    default domain suffix.
  * Relax commands to always normalize to user@domain even if a previous form
    of entry is given
  * Fix pam module to always be loaded for those.
  * All users and machine update should not provide a target
  * Relax rule for hostname length when > 15 characters. Try first real name
    in AD and then fallback to 15 for NETBIOS compatibility if AD is configured
    in such a way.
  * Pull sss connection state dynamically, to switch between online and offline
    mode.
  * Misc smaller fixes in namings and entry permissive mode.
  * Add and adapt unit and integration tests for all the above, including
    docker test container.
  * Fixes for incoming Golang 1.17 tests Name() behaviour change
  * Make some integration tests more stable
  * Refresh policy definition file
  * Update vendored dependency via DEPENDABOT:
    - github.com/fsnotify/fsnotify
    - github.com/godbus/dbus
    - golang.org/x/text
    - google.golang.org/grpc
    - gopkg.in/ini.v1
    - honnef.co/go/tools
  * CI:
    - switch back to hirsute for QA code check, as impish docker images have
      a broken libc.
  * Packaging fixes:
    - Ensure we always build with PIE
    - Fix autopkgtests by not running them as root
    - Ship NOTICE from a vendor dependency as being Apache2 licensed
    - Modernize gbp.conf

 -- Didier Roche <didrocks@ubuntu.com>  Wed, 15 Sep 2021 10:30:27 +0200

adsys (0.7) impish; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Depends on sssd offline status to try fetching the GPOs
    - request to sssd in what status we are in
    - if we are online, do the samba/ldap requests as we used to do, but
      with a contextual timeout.
  * Allow empty ad_server in sssd.conf.
  * Fix dependencies between service and relax adsys-boot retrials.
  * Pam to request machine update if no machine cache is available.a
  * Print N/A when no Active Server was found.
  * Refresh policy definition files
  * Updates to latest release of viper, cobra, protobuf, grpc.
  * Use cobra 2.0 completion.
  * Adapt and add new tests to previous changes
  * Reenable LTO optimization.

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 19 Jul 2021 13:01:07 +0200

adsys (0.6) impish; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Add a new status command, returning current user connected, mode, last
    refresh time and applied configuration
  * Add a new doc command, which allows listing the documentation or write a
    specific chapter on the terminal or disk.
  * Add a new debus hidden (system) command, which allows dumping
    adsys-gpolist and (in the future) various multiple debugging tools for a
    specific AD setup
  * Advance CI completion for users, machines and other contextual strings
    (requesting the service for available valid items, based on context).
  * Hook up CI to update online documentation (on github) and local offline
    one in two ways (updating the local doc will update the online one and
    vice-versa)
  * Write the whole documentation for setting up and using adsys
  * Refactor configuration handling and const location
  * Only start machine GPO download on boot (blocking) if we have AD configured
  * Fix pam integration by setting correct linker property
  * Fallback to sssd discovery active AD server
  * Fix GDM dconf keys to use for screen customization
  * New adsysservice to properly shutdown authorizer and move service dbus
    handling
  * Integrate gosec to CI and multiple fixes
  * Serialize adsys-gpolist and admx/adml in binary
  * Misc fixes in listing Active Directory GPO, multiple error cases
    graceful handling and fix some Windows requirements like spec names.
  * Small fixes and error message reformulation
  * Update all dependencies to latest version and hook up Dependabot in CI
  * Multiple CI enhancements
  * Fix for admx generation, allowing pointing at keys not present in a
    release if filtered out
  * Tighten build and package depdencies.
  * Tests:
    - add more configuration for integration tests
    - fix protobuf namespace conflicts
    - multiple refactoring
    - ensure local dbus are properly shutdown
    - fix some racy tests but being more relax on times
    - allow coverage for python code and subprocesses
    - add many new tests, including integration tests
    - replace wharthogs.biz domain by example.com. Thanks Paul Mars

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 21 Jun 2021 14:16:16 +0200

=== debian/control ===
--- 
+++ 
@@ -32,6 +32,6 @@
          python3-samba,
          samba-dsdb-modules,
          sssd,
-         krb5-config,
+         sssd-dbus,
 Description: ${source:Synopsis}
  ${source:Extended-Description}

## adsys 0.8.4

=== debian/changelog ===
adsys (0.8.4) jammy; urgency=medium

  * Sync refresh timer with Windows
  * Some lint fixes due to Go 1.18
  * Fix image reference in documentation

 -- Didier Roche <didrocks@ubuntu.com>  Wed, 06 Apr 2022 15:37:58 +0200

adsys (0.8.3) jammy; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Use ua attached instead of a specific ua feature to gate optional
    features.
  * Added and updated documentation for privilege escalation and scripts
    support.
  * New linter version trigger fix.
  * Dependencies update for latest bug fixes:
    - github.com/golangci/golangci-lint
    - github.com/spf13/cobra-1.4.0
    - github.com/stretchr/testify-1.7.1
    - google.golang.org/protobuf-1.28.0
    - google.golang.org/grpc-1.45.0

 -- Didier Roche <didrocks@ubuntu.com>  Wed, 23 Mar 2022 13:39:27 +0100

adsys (0.8.2) jammy; urgency=medium

  * Fix flaky "pick up config changes" tests on armhf and arm64

 -- Didier Roche <didrocks@ubuntu.com>  Thu, 10 Mar 2022 11:00:27 +0100

adsys (0.8.1) jammy; urgency=medium

  * Change chown logic on script directory and parents to avoid potential
    vulnerability. (LP: #1961458)
  * Separate readiness from session running to avoid unrefreshed user script
    directories after a logout without any new logins.
  * pam_adsys: Fix memory leak and identation. (LP: #1961459)
  * Adapt to newer samba, while keeping backward compatilibity for CI.
    Thanks Michael. (LP: #1962170)
  * Try to stabilize configuration detection change test by calling sync() to
    sync FHS to disk, and then, hoping we get the inotify update. Seems to fix
    flakyness on armhf. (LP: #1962510)
  * Enforce closing stderr on ppcel64 in tests with new samba to avoid hangs
    in race.
  * Fix linting issues discovered by new golangci-lint.
  * Misc syntax polish.
  * Dependencies update:
    - github.com/godbus/dbus/v5
    - github.com/golangci/golangci-lint
    - gopkg.in/ini.v1

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 08 Mar 2022 09:49:08 +0100

adsys (0.8) jammy; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Add new types of GPOs support, with ubuntu advantage subscription
    integration. Recommends ubuntu-advantage-desktop-daemon.
  * Privilege escalation: support for privilege escalation and gives
    administrator access to users and groups registered in Active Directory.
    The administrator can also prevent any kind of local administrator on
    the machine.
  * Scripts integration: support for scripts in GPO when the computer boots and
    shuts down, and when the user logs on or off.
    - The computer scripts are ran as root, on startup (or first AD user login
      if we couldn’t fetch GPOs and had no cache)
    - The user scripts are ran with systemd user session, as the user.
    - A transactional state is handled: New versions of scripts or list of
      scripts are only updated when a given session is not opened.
      Said differently, the shutdown scripts for the machine will be the ones
      downloaded and enabled when the start scripts were ran.
      Similarly, the user logoff scripts will be the ones corresponding to
      the time when the log on scripts were executed.
    - Any failing scripts won’t stop the boot or log on. Similarly to Windows
      script support, this is not a security feature.
  * Support downloading assets from the Active Directory server. Those assets
    are located in the <Distribution> named directory at SYSVOL root.
    Those needs a GPT.INI, similarly to GPO, to control cache update.
  * Internal changes on how policies and cached are handled. Those changes are
    needed to enhance the model of caching with assets, while keeping
    a transactional behaviour.
  * Many new tests covering all the new and existing changes.
  * General cleanups:
    - More debugging and info messages.
    - In templates, policies define personalized notes and descriptions.
      Those are now used to generate the description of the policy.
    - Modernize, fix bugs and workarounds now that we are on at min Go 1.16,
      and prepare for 1.17 and new vendored dependencies versions.
    - Add more linting support and fix discovered issues.
    - Rewrite integration tests containers mimicking system services in python
      for better reliability and support via dbus-mock. Upgraded to a newer
      version.
    - Adapt to new GitHub infrastructure changes with new container repository,
      and change workflows adjustements by new linting rules.
    - Discare deprecated dconf keys for those releases.
  * Updated vendored go dependencies:
    - bluemonday
    - cobra
    - color
    - glamour
    - go-dbus
    - golangci-lint
    - grpc
    - ini
    - viper

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 07 Feb 2022 09:37:45 +0100

=== debian/control ===
--- 
+++ 
@@ -33,5 +33,7 @@
          samba-dsdb-modules,
          sssd,
          sssd-dbus,
+Recommends: ${misc:Recommends},
+            ubuntu-advantage-desktop-daemon,
 Description: ${source:Synopsis}
  ${source:Extended-Description}

=== debian/rules ===
--- 
+++ 
@@ -2,14 +2,10 @@
 #export DH_VERBOSE = 1
 
 export GOCACHE=$(shell mktemp -d /tmp/gocache-XXXX)
-export GOFLAGS=-ldflags=-X=github.com/ubuntu/adsys/internal/config.Version=$(shell dpkg-parsechangelog -S Version) --mod=vendor
-export DH_GOLANG_INSTALL_EXTRA := internal/policies/ad/admxgen/admx.template internal/policies/ad/admxgen/adml.template
+export GOFLAGS=-ldflags=-X=github.com/ubuntu/adsys/internal/consts.Version=$(shell dpkg-parsechangelog -S Version) --mod=vendor -buildmode=pie
 
 # Install all content to embed
 export DH_GOLANG_INSTALL_ALL := 1
-
-# The package fails to build on duplicate symbols in the archive with LTO enabled
-export DEB_BUILD_MAINT_OPTIONS=optimize=-lto
 
 # Skip integration tests when building package: they need docker images.
 export ADSYS_SKIP_INTEGRATION_TESTS=1

=== debian/tests/control ===
# Skip integration tests when building package: they need docker images.
Test-Command: ADSYS_SKIP_INTEGRATION_TESTS=1 go test -v -mod=vendor ./...
Restrictions: allow-stderr
Depends: @builddeps@

## adsys 0.9.2~20.04.1

=== debian/changelog ===
adsys (0.9.2~20.04.1) focal-security; urgency=medium

  * No change build due to golang-1.18 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Thu, 27 Apr 2023 11:40:35 +0530

adsys (0.9.2~20.04) focal; urgency=medium

  * Backport to focal
    - Build with Go 1.16
    - Move debhelper compat to 12
    - Do not recommends ubuntu-advantage-desktop-daemon as it’s not available
      on focal yet.

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Thu, 04 Aug 2022 12:25:29 +0300

adsys (0.9.2) kinetic; urgency=medium

  * Update generators to fix FTBFS
    - shell out to mkdir instead of go's os.Mkdir which can bypass fakeroot's
      filesystem hijacking and cause unexpected behavior
  * Update dependencies to latest:
    - github.com/golangci/golangci-lint
    - google.golang.org/protobuf

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Wed, 03 Aug 2022 11:00:39 +0300

adsys (0.9.1) kinetic; urgency=medium

  [ Didier Roche ]
  [ Gabriel Nagy ]
  * Fix loading policy content from uppercase folders (LP: #1982330)
  * Add GSettings power management keys (LP: #1982349)
  * Allow parsing policy entries with empty values (LP: #1982342)
  * Allow parsing policies with unsupported types (LP: #1982343)
  * Allow parsing policy entries with no data (LP: #1982345)
  * Lowercase target name when normalizing (LP: #1982347)
  * Annotate policies that require Ubuntu Pro (LP: #1982348)
  * Update dependencies to latest:
    - github.com/spf13/cobra
    - github.com/spf13/viper
    - github.com/stretchr/testify
    - github.com/charmbracelet/bubbletea
    - github.com/charmbracelet/bubbles
    - google.golang.org/grpc
    - github.com/golangci/golangci-lint
    - github.com/sirupsen/logrus

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Thu, 21 Jul 2022 11:44:30 +0300

adsys (0.9.0) kinetic; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  [ Gabriel Nagy ]
  * Add Active Directory Watch Daemon - adwatchd: (LP: #1982351)
    - Implement a Windows daemon that watches a list of configured directories
      for changes and bumps the relevant GPT.INI files.
    - Add adsys-windows binary package which includes the Windows daemon
      executable and the admx/adml policies.
  * Config detection now includes current executable directory
  * Fixes in generator build race
  * Update dependencies to latest:
    - github.com/spf13/cobra
    - github.com/stretchr/testify
  * CI updates:
    - switch to Go setup v3
    - bump to really build with Golang 1.18

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Mon, 04 Jul 2022 16:36:52 +0300

adsys (0.8.6) kinetic; urgency=medium

  * Fix new build failures on 32 bits due to libsmbclient-dev no longer sets
    the large file support cflags in libsmbclient.h.
    Update to latest libsmbclient-go.
  * Update dependencies to latest:
    - google.golang.org/grpc
    - gopkg.in/ini.v1
    - github.com/golangci/golangci-lint
    - github.com/spf13/viper
    - github.com/stretchr/testify

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 07 Jun 2022 16:17:12 +0200

adsys (0.8.5) kinetic; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Rename chapters to be in correct ascii order when viewed online.
    Thanks to Anton Drastrup-Fjordbak.
  * Include 22.04 in admx/adml for lts only releases. (LP: #1973745)
  * Bump embedeed dependencies minor versions for both bug fixes and minor
    security enhancements.
  * Fix dconf keys not being readable by user after applying policy.
    (LP: #1973748)
  * Ensure we can execute machine and user scripts:
    /run is now noexec on Ubuntu. Ensure that we can execute the scripts in
    /run/adsys subdirectories. The scripts mechanism has been reviewed by the
    security team, so we can reset them as executable. (LP: #1973751)
  * Move integration tests under cmd/adsysd and admxgen binary to cmd/admxgen
    to prepare future adwatchd daemon under cmd/ which will be SRUed with an
    exception in next update. This is a no-op in the finale deploy binaries,
    apart from admxgen which is now using Cobra. This binary though is not
    shipped in any package and only used in CI.
  * Fix privilege permission which can not be set to disabled. (LP: #1973752)
  * Adaptation or new tests for all above changes.
  * Add fuzz tests and include new potential crash fixes on invalid files
    generated by Windows AD.
  * CI fixes and changes (not impacting finale package):
    - Move CI to Go 1.18 (package is already building with 1.18 in jammy).
    - Fixes due to new github.
    - Fix to generate all LTS releases in admx/adml (see above).


 -- Didier Roche <didrocks@ubuntu.com>  Mon, 16 May 2022 14:09:36 +0200

## adsys 0.9.2~20.04.2

=== debian/changelog ===
adsys (0.9.2~20.04.2) focal; urgency=medium

  [ Didier Roche ]
  [ Matthew Ruffell ]
  * Fix processing of domain names to correctly parse '-' characters
    when creating valid dbus object paths, enabling domains with
    '-' to work, e.g. "test-example.com". (LP: #2020834)
    - internal/ad/ad.go

 -- Matthew Ruffell <matthew.ruffell@canonical.com>  Fri, 26 May 2023 15:57:39 +1200

## adsys 0.9.2~20.04.2ubuntu0.1

=== vendor/github.com/ettle/strcase/Makefile ===
.PHONY: benchmark docs lint test

docs:
	which godoc2ghmd || ( go get github.com/DevotedHealth/godoc2ghmd && go mod tidy )
	godoc2ghmd -template .readme.tmpl github.com/ettle/strcase > README.md

test:
	go test -cover ./...

lint:
	which golangci-lint || ( go get github.com/golangci/golangci-lint/cmd/golangci-lint@v1.27.0 && go mod tidy )
	golangci-lint run
	golangci-lint run benchmark/*.go

benchmark:
	cd benchmark && go test -bench=. -test.benchmem && go mod tidy

=== debian/changelog ===
adsys (0.9.2~20.04.2ubuntu0.1) focal-security; urgency=medium

  * SECURITY UPDATE: Denial of service in parse function.
    - Use strings.EqualFold instead of direct comparison and
      strings.ToLower in .../html/doctype.go, .../html/foreign.go, and
      .../html/parse.go. Based on
      https://go.googlesource.com/net/+/8e66b04771e35c4e4125e8c60334b34e2423effb
      upstream patch.
    - CVE-2024-45338

 -- Hlib Korzhynskyy <hlib.korzhynskyy@canonical.com>  Tue, 07 Jan 2025 14:29:24 -0330

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: debhelper-compat (= 12),
                dh-apport,
                dh-golang,
-               golang-go (>= 2:1.16~),
+               golang-1.18-go,
                libsmbclient-dev,
                libdbus-1-dev,
                python3,
@@ -34,6 +34,17 @@
          sssd,
          sssd-dbus,
 Recommends: ${misc:Recommends},
-            ubuntu-advantage-desktop-daemon,
 Description: ${source:Synopsis}
  ${source:Extended-Description}
+
+Package: adsys-windows
+Architecture: amd64 arm64
+Built-Using: ${misc:Built-Using},
+Depends: ${shlibs:Depends},
+         ${misc:Depends},
+Description: ${source:Synopsis}
+ ${source:Extended-Description}
+ .
+ This package contains all the assets and binaries to install
+ on the Active Directory Windows server.
+ The binaries are Windows executables.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export GOCACHE=$(shell mktemp -d /tmp/gocache-XXXX)

WIN_ARCHS := amd64 arm64
WIN_GOFLAGS := -ldflags=-X=github.com/ubuntu/adsys/internal/consts.Version=$(shell dpkg-parsechangelog -S Version) --mod=vendor
export GOFLAGS := $(WIN_GOFLAGS) -buildmode=pie

# PIE on Windows is only supported for amd64
ifeq ($(shell dpkg --print-architecture),amd64)
	WIN_GOFLAGS += -buildmode=pie
endif

# Only build adwatchd on supported architectures
ifneq ($(filter $(shell dpkg --print-architecture),$(WIN_ARCHS)),)
	WINDOWS_BUILD := 1
endif

# Copy in build directory all content to embed
export DH_GOLANG_INSTALL_ALL := 1

# Skip integration tests when building package: they need docker images
export ADSYS_SKIP_INTEGRATION_TESTS=1

# Skip tests that require sudo: they will run as part of autopkgtests
export ADSYS_SKIP_SUDO_TESTS=1

# Run with Go 1.18
export PATH := /usr/lib/go-1.18/bin/:$(PATH)

%:
	dh $@ --buildsystem=golang --with=golang,apport

override_dh_auto_clean:
	dh_auto_clean
	# Create the vendor directory when building the source package
	[ -d vendor/ ] || go mod vendor

override_dh_auto_build:
	# Build on linux only adsysd itself, and not generator or Windows binaries
	DH_GOLANG_BUILDPKG=github.com/ubuntu/adsys/cmd/adsysd dh_auto_build

# Build the Windows executables for adwatchd where applicable
ifeq ($(WINDOWS_BUILD),1)
	GOFLAGS="$(WIN_GOFLAGS)" GOOS=windows DH_GOLANG_BUILDPKG=github.com/ubuntu/adsys/cmd/adwatchd dh_auto_build
endif

override_dh_auto_install:
	dh_auto_install -- --no-source

	# PAM configuration
	mkdir -p debian/tmp/usr/share/pam
	cp -a pam/pam-configs debian/tmp/usr/share

	# systemd services
	mkdir -p debian/tmp/lib/systemd/system debian/tmp/usr/lib/systemd/user
	cp -a systemd/*.mount debian/tmp/lib/systemd/system/
	cp -a systemd/*.service debian/tmp/lib/systemd/system/
	cp -a systemd/*.socket debian/tmp/lib/systemd/system/
	cp -a systemd/*.timer debian/tmp/lib/systemd/system/
	cp -a systemd/user/*.service debian/tmp/usr/lib/systemd/user/

# Separate windows binaries
ifeq ($(WINDOWS_BUILD),1)
	mkdir -p debian/tmp/usr/share/adsys/windows
	mv debian/tmp/usr/bin/windows_*/* debian/tmp/usr/share/adsys/windows
	rmdir debian/tmp/usr/bin/windows_*

	# Ship admx/adml for ubuntu
	cp -a policies/Ubuntu debian/tmp/usr/share/adsys/windows/policies
endif

	# Install in /sbin
	mv debian/tmp/usr/bin/ debian/tmp/sbin
	# Create adsysctl command
	ln -s adsysd debian/tmp/sbin/adsysctl
	# Run go generate to install assets, but don’t regenerate them
	GENERATE_ONLY_INSTALL_TO_DESTDIR=$(CURDIR)/debian/tmp go generate -x -tags tools $(GOFLAGS) ./...

## adsys 0.9.2~22.04.1

=== debian/changelog ===
adsys (0.9.2~22.04.1) jammy-security; urgency=medium

  * No change build due to golang-1.18 update 

 -- Nishit Majithia <nishit.majithia@canonical.com>  Thu, 27 Apr 2023 11:41:22 +0530

adsys (0.9.2~22.04) jammy; urgency=medium

  * Backport to jammy

 -- Didier Roche <didrocks@ubuntu.com>  Thu, 04 Aug 2022 11:23:01 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                dh-apport,
                dh-golang,
-               golang-1.18-go,
+               golang-go (>= 2:1.16~),
                libsmbclient-dev,
                libdbus-1-dev,
                python3,
@@ -34,6 +34,7 @@
          sssd,
          sssd-dbus,
 Recommends: ${misc:Recommends},
+            ubuntu-advantage-desktop-daemon,
 Description: ${source:Synopsis}
  ${source:Extended-Description}

## adsys 0.9.2~22.04.2

=== debian/changelog ===
adsys (0.9.2~22.04.2) jammy; urgency=medium

  [ Didier Roche ]
  [ Matthew Ruffell ]
  * Fix processing of domain names to correctly parse '-' characters
    when creating valid dbus object paths, enabling domains with
    '-' to work, e.g. "test-example.com". (LP: #2020834)
    - internal/ad/ad.go

 -- Matthew Ruffell <matthew.ruffell@canonical.com>  Fri, 26 May 2023 15:52:48 +1200

## adsys 0.9.2

=== debian/rules ===
--- 
+++ 
@@ -25,9 +25,6 @@
 
 # Skip tests that require sudo: they will run as part of autopkgtests
 export ADSYS_SKIP_SUDO_TESTS=1
-
-# Run with Go 1.18
-export PATH := /usr/lib/go-1.18/bin/:$(PATH)
 
 %:
 	dh $@ --buildsystem=golang --with=golang,apport

## adsys 0.11.0

=== debian/changelog ===
adsys (0.11.0) lunar; urgency=medium

  [ Denison Barbosa ]
  [ Gabriel Nagy ]
  * List Pro policy types in service status output
  * Warn when Pro-only rules are configured
  * Use systemd via D-Bus instead of systemctl commands
  * Add placeholder notes for entry types
  * Add guideline docs to the policy managers
  * Change Ubuntu Advantage to Ubuntu Pro in docs
  * Add system proxy policy manager (LP: #2012371)
  * Update dependencies to latest:
    - github.com/charmbracelet/lipgloss
    - github.com/coreos/go-systemd/v22
    - github.com/fatih/color
    - github.com/golangci/golangci-lint
    - github.com/golang/protobuf
    - golang.org/x/net
    - google.golang.org/grpc
    - google.golang.org/grpc/cmd/protoc-gen-go-grpc
    - google.golang.org/protobuf
  * CI and quality of life changes not impacting package functionality:
    - Bump github actions to latest:
      - actions/setup-go
    - Update Rust related auto update jobs
    - Replace testutils.Setenv with t.Setenv
    - Set up more tests to run in parallel
    - Various test refactors and improvements

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Tue, 04 Apr 2023 19:40:35 +0300

adsys (0.10.1) lunar; urgency=medium

  [ Denison Barbosa ]
  [ Jean-Baptiste Lallement ]
  [ Gabriel Nagy ]
  [ Didier Roche ]
  * Fix erroneous non alternative dependency on package krb5-user
  * Fix a bug in internal/config tests that was causing the autopkgtests to fail
  * Update internal/config to also trigger a reload when config file is
    overwritten
  * Update dependencies to latest:
    - github.com/golangci/golangci-lint
    - github.com/stretchr/testify
  * CI and quality of life changes not impacting package functionality:
    - Bump github actions to latest:
      - peter-evans/create-pull-request
      - actions/download-artifact
    - Addressing some linter issues pointed out by new golangci-lint version

 -- Denison Barbosa <denison.barbosa@canonical.com>  Thu, 02 Mar 2023 09:43:33 -0400

adsys (0.10.0) lunar; urgency=medium

  [ Denison Barbosa ]
  [ Jean-Baptiste Lallement ]
  [ Gabriel Nagy ]
  [ Didier Roche ]
  * Add mount / network shares policy manager
    - this is an Ubuntu Pro feature that allows mounting network shares at a
      user or machine level
    - supported mount types: smb, nfs, and ftp (after installing curlftpfs)
    - supported authentication: anonymous (default), krb5
    - user mounts are handled at login by a Rust binary now shipped with adsys
      Thanks to schopin for the packaging guidance and contributions
    - computer mounts are handled by systemd mount units requiring root
      privileges
  * Add AppArmor policy manager
    - this is an Ubuntu Pro feature that allows enforcing application
      confinement at a user or machine level using AppArmor
    - user policies rely on the libpam-apparmor package which must be
      installed manually
  * Support multiple AD backends and implement Winbind support
    - sssd is still the default backend, but winbind can be opted into through
      the adsys.yaml configuration file
  * Add a --machine / -m flag to adsysctl applied, indicating the policies
    applied to the current machine
  * Expose Ubuntu Pro status in the "status" command
    - status is now fetched dynamically instead of relying on a possibly
      outdated state when updating policies
  * Update scripts manager creation
    - scripts manager now creates both an users and machine directory on
      initialization
  * Fix policy update failing when GPT.INI contains no version key
  * Fix object lookup for users having a FQDN as their hostname
  * Support special characters in domains when parsing sssd configuration
  * Reduce dependencies by excluding CI tools from go.mod
    - tooling-related packages are now vendored in a separate go.mod file,
      allowing for a smaller source package
  * Replace gopkg.in/yaml.v2 with gopkg.in/yaml.v3
    Thanks to Juneezee for the contribution
  * Clean-up packaging scripts related to the user mount handler
    Thanks to liushuyu for the contribution
  * CI and quality of life changes not impacting package functionality:
    - Add golden functionality to testutils
    - Switch to new fsnotify event check syntax
    - Move adsysgpotests to golden generated by testutils
    - Fix test helper permission when making directory RO
    - Rework skipping integration tests
    - Compare golden tree executable permissions
    - Allow running mount_handler tests as part of go test
    - Fix python coverage in integration tests
    - Factorize some coverage testutils functions
    - Refactor tracking and generating coverage files
    - Implement session dbus mock
    - Stabilize integration test coverage
    - Fix set-output GitHub Actions deprecation warning
    - Reuse our utility function for comparing trees
    - Install missing packages for auto-updates workflow
    - Update d/copyright to account for the new Rust dependencies
    - Fix FTBFS on Launchpad introduced by the latest unreleased work
    - Standardize on test case naming and use the previously added testutils
      functions for golden file comparison
  * Update dependencies to latest:
    - github.com/charmbracelet/bubbles
    - github.com/charmbracelet/bubbletea
    - github.com/charmbracelet/glamour
    - github.com/charmbracelet/lipgloss
    - github.com/fatih/color
    - github.com/fsnotify/fsnotify
    - github.com/golangci/golangci-lint
    - github.com/kardianos/service
    - github.com/muesli/termenv
    - github.com/spf13/cobra
    - github.com/spf13/viper
    - github.com/stretchr/testify
    - golang.org/x/net
    - golang.org/x/sys
    - golang.org/x/text
    - google.golang.org/grpc
    - gopkg.in/ini.v1

 -- Gabriel Nagy <gabriel.nagy@canonical.com>  Thu, 22 Feb 2023 18:16:25 +0200

=== debian/control ===
--- 
+++ 
@@ -4,23 +4,28 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: debhelper-compat (= 13),
                dh-apport,
+               dh-cargo,
                dh-golang,
                golang-go (>= 2:1.16~),
                libsmbclient-dev,
                libdbus-1-dev,
+               libglib2.0-dev,
                python3,
                python3-samba,
                samba-dsdb-modules,
                libpam0g-dev,
                samba,
                dbus,
+               libwbclient-dev,
+               apparmor,
 Standards-Version: 4.5.1
 XS-Go-Import-Path: github.com/ubuntu/adsys
+XS-Vendored-Sources-Rust: anyhow@1.0.66, autocfg@1.1.0, bitflags@1.3.2, cfg-expr@0.11.0, cfg-if@1.0.0, futures-channel@0.3.25, futures-core@0.3.25, futures-executor@0.3.25, futures-io@0.3.25, futures-macro@0.3.25, futures-task@0.3.25, futures-util@0.3.25, gio-sys@0.16.3, gio@0.16.7, glib-macros@0.16.3, glib-sys@0.16.3, glib@0.16.7, gobject-sys@0.16.3, heck@0.4.0, itoa@1.0.4, libc@0.2.137, log@0.4.17, once_cell@1.16.0, pin-project-lite@0.2.9, pin-utils@0.1.0, pkg-config@0.3.26, proc-macro-crate@1.2.1, proc-macro-error-attr@1.0.4, proc-macro-error@1.0.4, proc-macro2@1.0.47, quote@1.0.21, ryu@1.0.11, serde@1.0.148, serde_derive@1.0.148, serde_json@1.0.89, slab@0.4.7, smallvec@1.10.0, syn@1.0.104, system-deps@6.0.3, thiserror-impl@1.0.37, thiserror@1.0.37, time-core@0.1.0, time-macros@0.2.6, time@0.3.17, toml@0.5.9, unicode-ident@1.0.5, version-compare@0.1.1, version_check@0.9.4, winapi-i686-pc-windows-gnu@0.4.0, winapi-x86_64-pc-windows-gnu@0.4.0, winapi@0.3.9
 Homepage: https://github.com/ubuntu/adsys
 Description: AD SYStem integration
  ADSys is an AD SYStem tool to integrate GPOs with a linux system.
  It allows one to handle machine and users GPOs, mapping them to dconf keys,
- apparmor rules and running scripts at different point in time.
+ apparmor rules, mounts, proxy settings and running scripts at different points in time.
 
 
 Package: adsys
@@ -31,10 +36,16 @@
          python3,
          python3-samba,
          samba-dsdb-modules,
-         sssd,
-         sssd-dbus,
+         sssd | winbind,
+         sssd | krb5-user,
+         sssd-dbus | winbind,
+         apparmor,
+         cifs-utils,
+         gvfs,
 Recommends: ${misc:Recommends},
             ubuntu-advantage-desktop-daemon,
+Suggests: curlftpfs,
+          ubuntu-proxy-manager,
 Description: ${source:Synopsis}
  ${source:Extended-Description}

=== debian/rules ===
--- 
+++ 
@@ -21,22 +21,74 @@
 export DH_GOLANG_INSTALL_ALL := 1
 
 # Skip integration tests when building package: they need docker images
+# Tests needing sudo will be skipped automatically
 export ADSYS_SKIP_INTEGRATION_TESTS=1
 
-# Skip tests that require sudo: they will run as part of autopkgtests
-export ADSYS_SKIP_SUDO_TESTS=1
+# Do not run Rust tests from Golang, as they're run independently via
+# dh-cargo, allowing integration with vendored deps, etc...
+export ADSYS_SKIP_RUST_TESTS_IN_GOLANG=1
+
+# The following definitions are necessary because of the manual steps
+# we need to do to work around some issues with either dh-cargo,
+# the wrapper, or cargo
+include /usr/share/rustc/architecture.mk
+CARGO := /usr/share/cargo/bin/cargo
+ADSYS_MOUNT := internal/policies/mount/adsys_mount
+
+# Needed for Rust vendored sources tracking
+DH_CARGO_VENDORED_SOURCES := /usr/share/cargo/bin/dh-cargo-vendored-sources
+export CARGO_VENDOR_DIR = vendor_rust
 
 %:
 	dh $@ --buildsystem=golang --with=golang,apport
 
 override_dh_auto_clean:
 	dh_auto_clean
+	dh_auto_clean --buildsystem=cargo
 	# Create the vendor directory when building the source package
 	[ -d vendor/ ] || go mod vendor
+	# Some crates are shipped with .a files, which get removed by the helpers during the package build as a safety measure.
+	# This results in cargo failing to compile, since the files (which are listed in the checksums) are not there anymore.
+	# For those crates, we need to replace their checksum with a more general one that only lists the crate checksum, instead of each file.
+	if [ ! -d $(CARGO_VENDOR_DIR)/ ]; then \
+		$(CARGO) vendor $(CARGO_VENDOR_DIR); \
+		[ ! -e $(DH_CARGO_VENDORED_SOURCES) ] || $(DH_CARGO_VENDORED_SOURCES); \
+		\
+		[ -e /usr/bin/jq ] || (echo "jq is required to run this script. Try installing it with 'sudo apt install jq'" && exit 1); \
+		\
+		for dep in $$(ls vendor_rust -1); do \
+			checksum_file="vendor_rust/$${dep}/.cargo-checksum.json"; \
+			a_files=$$(cat $${checksum_file} | jq '.files | keys | map(select(.|test(".a$$")))'); \
+			if [ "$$a_files" = "[]" ]; then \
+				continue; \
+			fi; \
+			pkg_checksum=$$(cat "$${checksum_file}" | jq '.package'); \
+			echo "{\"files\": {}, \"package\": $${pkg_checksum}}" >"$${checksum_file}"; \
+		done; \
+	fi
+	# That last line above is to warn whoever's doing the packaging that they
+	# need to update the Vendored-Sources field. The initial packaging work
+	# didn't include said field since the vendoring is done on the fly.
+
+override_dh_auto_configure:
+	dh_auto_configure
+	# The following lines basically do the same thing as
+	# `dh_auto_configure --buildsystem=cargo`
+	# on Kinetic and above, but since we're supporting Jammy as well,
+	# we need to do it manually. Note that we don't want to export CARGO_HOME
+	# in the global debian/rules as it would interfere with the clean target
+	[ ! -e $(DH_CARGO_VENDORED_SOURCES) ] || $(DH_CARGO_VENDORED_SOURCES)
+	DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) DEB_HOST_RUST_TYPE=$(DEB_HOST_RUST_TYPE) \
+		CARGO_HOME=$(CURDIR)/debian/cargo_home DEB_CARGO_CRATE=adsys_$(shell dpkg-parsechangelog --show-field Version) \
+		$(CARGO) prepare-debian $(CARGO_VENDOR_DIR)
 
 override_dh_auto_build:
 	# Build on linux only adsysd itself, and not generator or Windows binaries
 	DH_GOLANG_BUILDPKG=github.com/ubuntu/adsys/cmd/adsysd dh_auto_build
+
+override_dh_auto_test:
+	dh_auto_test --buildsystem=cargo -- test --all
+	dh_auto_test
 
 # Build the Windows executables for adwatchd where applicable
 ifeq ($(WINDOWS_BUILD),1)
@@ -45,6 +97,22 @@
 
 override_dh_auto_install:
 	dh_auto_install -- --no-source
+
+	# Here we utilise a logical flaw in the cargo wrapper to our advantage:
+	# when specifying DEB_CARGO_CRATE_IN_REGISTRY=1, the wrapper will
+	# avoid adding the `--path` option, so that we can specify it ourselves
+	DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) \
+	DEB_HOST_RUST_TYPE=$(DEB_HOST_RUST_TYPE) \
+	CARGO_HOME=$(CURDIR)/debian/cargo_home \
+	DEB_CARGO_CRATE=adsys_mount_0.1.0 \
+	DEB_CARGO_CRATE_IN_REGISTRY=1 \
+	DESTDIR=$(CURDIR)/debian/tmp \
+        $(CARGO) install --path $(ADSYS_MOUNT)
+	# Currently doesn't work because of https://github.com/rust-lang/cargo/issues/4101
+	# combined with a lack of flexibility in the cargo wrapper. That means we
+	# have to do it manually (with the build split out in dh_auto_build for good
+	# measure, even though dh-cargo does it all in the install step)
+	# dh_auto_install --buildsystem=cargo -- --path $(ADSYS_MOUNT)
 
 	# PAM configuration
 	mkdir -p debian/tmp/usr/share/pam

## adsys 0.11.0ubuntu0.1

=== debian/changelog ===
adsys (0.11.0ubuntu0.1) lunar-security; urgency=medium

  * No change rebuild due to golang-1.20, golang-1.21 updates

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 17 Jan 2024 14:59:13 +0530
